> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://help.sigmacomputing.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://help.sigmacomputing.com/_mcp/server.

# Swap workbook connections (Beta)

POST https://api.sigmacomputing.com/v2/workbooks/{workbookId}/swapConnections
Content-Type: application/json

Swap the connections used by a workbook. You can update custom SQL elements to query a different connection, and optionally swap warehouse tables and copy input table data.

**Beta**: This documentation describes a public beta feature and is subject to the [Beta features](/docs/sigma-product-releases#beta-features) disclaimer.

### Usage notes
- Retrieve the **workbookId** by calling the [/v2/workbooks](https://help.sigmacomputing.com/reference/list-workbooks) endpoint.
- Retrieve the **connectionId** by calling the [/v2/connections](https://help.sigmacomputing.com/reference/list-connections) endpoint.
- To swap warehouse tables in a connection, set the `swapTables` option to `true`. Custom SQL elements and input tables follow the connection mapping whether or not `swapTables` is set.

  - Use the `paths` option to specify the connection paths to swap. The connection path is a list of strings that represents the path to the table in the cloud data warehouse. For example, `["database", "schema", "table"]`.
  - If the table schema is the same in both connections, leave the `paths` option empty to swap all warehouse tables in the connection. You can also pass a partial path to swap between databases, catalogs, or schemas.

- Set `copyInputTableData` to `true` to copy input table rows onto the new connection. When omitted or `false`, input table connections are updated without copying row data.
  

Reference: https://help.sigmacomputing.com/reference/swap-workbook-connections

## Authentication

- OAuth2 — send the obtained token as `Authorization: Bearer <token>`

## Servers

- `https://api.sigmacomputing.com` (Server for GCP (US) hosted organizations, default)
- `https://api.sa.gcp.sigmacomputing.com` (Server for GCP (KSA) hosted organizations)
- `https://api.uk.gcp.sigmacomputing.com` (Server for GCP (UK) hosted organizations)
- `https://aws-api.sigmacomputing.com` (Server for AWS US (West) hosted organizations)
- `https://api.us-a.aws.sigmacomputing.com` (Server for AWS US (East) hosted organizations)
- `https://api.ca.aws.sigmacomputing.com` (Server for AWS Canada hosted organizations)
- `https://api.eu.aws.sigmacomputing.com` (Server for AWS Europe (Frankfurt) hosted organizations)
- `https://api.ch.aws.sigmacomputing.com` (Server for AWS Europe (Zurich) hosted organizations)
- `https://api.au.aws.sigmacomputing.com` (Server for AWS Australia and APAC hosted organizations)
- `https://api.uk.aws.sigmacomputing.com` (Server for AWS UK hosted organizations)
- `https://api.in.aws.sigmacomputing.com` (Server for AWS Asia Pacific (Mumbai) hosted organizations)
- `https://api.us.azure.sigmacomputing.com` (Server for Azure US hosted organizations)
- `https://api.eu.azure.sigmacomputing.com` (Server for Azure Europe hosted organizations)
- `https://api.ca.azure.sigmacomputing.com` (Server for Azure Canada hosted organizations)
- `https://api.uk.azure.sigmacomputing.com` (Server for Azure United Kingdom hosted organizations)
- `https://api.au.azure.sigmacomputing.com` (Server for Azure Australia hosted organizations)

## Request

### Path parameters

- `workbookId` (string, required) — Unique identifier of the workbook.

### Body (application/json)

This endpoint expects an object.

- `connectionMapping` (list of V2WorkbooksWorkbookIdSwapConnectionsPostRequestBodyContentApplicationJsonSchemaConnectionMappingItems, required) — Connections to swap.
- `copyInputTableData` (boolean, optional) — When true, copy input table rows onto the swapped connection. When false or omitted, input table connections are updated without copying row data.

## Response

### 200

The response body.

- `unswappedSources` (list of string, required) — IDs of sources in the workbook that were not swapped.
- `unswappedConnections` (list of string, required) — IDs of custom SQL connections in the workbook that were not swapped.

## Types

### V2WorkbooksWorkbookIdSwapConnectionsPostRequestBodyContentApplicationJsonSchemaConnectionMappingItems

- `fromId` (string, required) — ID of the connection to swap from.
- `toId` (string, required) — ID of the connection to swap to.
- `swapTables` (boolean, optional) — Whether to swap warehouse tables in the connection.
- `paths` (list of V2WorkbooksWorkbookIdSwapConnectionsPostRequestBodyContentApplicationJsonSchemaConnectionMappingItemsPathsItems, optional)

### V2WorkbooksWorkbookIdSwapConnectionsPostRequestBodyContentApplicationJsonSchemaConnectionMappingItemsPathsItems

- `fromPath` (list of string, required) — Connection path of the form ['DATABASE', 'SCHEMA', 'TABLE']
- `toPath` (list of string, required) — Connection path of the form ['DATABASE', 'SCHEMA', 'TABLE']

## Examples

### Swap one connection

**Request**

```json
{
  "connectionMapping": [
    {
      "fromId": "11111111-1111-1111-1111-111111111111",
      "toId": "22222222-2222-2222-2222-222222222222",
      "swapTables": true
    }
  ],
  "copyInputTableData": true
}
```

**Response**

```json
{
  "unswappedSources": [
    "string"
  ],
  "unswappedConnections": [
    "string"
  ]
}
```

**SDK Code**

```python Swap one connection
import requests

url = "https://api.sigmacomputing.com/v2/workbooks/workbookId/swapConnections"

payload = {
    "connectionMapping": [
        {
            "fromId": "11111111-1111-1111-1111-111111111111",
            "toId": "22222222-2222-2222-2222-222222222222",
            "swapTables": True
        }
    ],
    "copyInputTableData": True
}
headers = {
    "Authorization": "<token>.",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript Swap one connection
const url = 'https://api.sigmacomputing.com/v2/workbooks/workbookId/swapConnections';
const options = {
  method: 'POST',
  headers: {Authorization: '<token>.', 'Content-Type': 'application/json'},
  body: '{"connectionMapping":[{"fromId":"11111111-1111-1111-1111-111111111111","toId":"22222222-2222-2222-2222-222222222222","swapTables":true}],"copyInputTableData":true}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Swap one connection
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.sigmacomputing.com/v2/workbooks/workbookId/swapConnections"

	payload := strings.NewReader("{\n  \"connectionMapping\": [\n    {\n      \"fromId\": \"11111111-1111-1111-1111-111111111111\",\n      \"toId\": \"22222222-2222-2222-2222-222222222222\",\n      \"swapTables\": true\n    }\n  ],\n  \"copyInputTableData\": true\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "<token>.")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Swap one connection
require 'uri'
require 'net/http'

url = URI("https://api.sigmacomputing.com/v2/workbooks/workbookId/swapConnections")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = '<token>.'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"connectionMapping\": [\n    {\n      \"fromId\": \"11111111-1111-1111-1111-111111111111\",\n      \"toId\": \"22222222-2222-2222-2222-222222222222\",\n      \"swapTables\": true\n    }\n  ],\n  \"copyInputTableData\": true\n}"

response = http.request(request)
puts response.read_body
```

```java Swap one connection
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.sigmacomputing.com/v2/workbooks/workbookId/swapConnections")
  .header("Authorization", "<token>.")
  .header("Content-Type", "application/json")
  .body("{\n  \"connectionMapping\": [\n    {\n      \"fromId\": \"11111111-1111-1111-1111-111111111111\",\n      \"toId\": \"22222222-2222-2222-2222-222222222222\",\n      \"swapTables\": true\n    }\n  ],\n  \"copyInputTableData\": true\n}")
  .asString();
```

```php Swap one connection
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.sigmacomputing.com/v2/workbooks/workbookId/swapConnections', [
  'body' => '{
  "connectionMapping": [
    {
      "fromId": "11111111-1111-1111-1111-111111111111",
      "toId": "22222222-2222-2222-2222-222222222222",
      "swapTables": true
    }
  ],
  "copyInputTableData": true
}',
  'headers' => [
    'Authorization' => '<token>.',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp Swap one connection
using RestSharp;

var client = new RestClient("https://api.sigmacomputing.com/v2/workbooks/workbookId/swapConnections");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "<token>.");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"connectionMapping\": [\n    {\n      \"fromId\": \"11111111-1111-1111-1111-111111111111\",\n      \"toId\": \"22222222-2222-2222-2222-222222222222\",\n      \"swapTables\": true\n    }\n  ],\n  \"copyInputTableData\": true\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift Swap one connection
import Foundation

let headers = [
  "Authorization": "<token>.",
  "Content-Type": "application/json"
]
let parameters = [
  "connectionMapping": [
    [
      "fromId": "11111111-1111-1111-1111-111111111111",
      "toId": "22222222-2222-2222-2222-222222222222",
      "swapTables": true
    ]
  ],
  "copyInputTableData": true
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.sigmacomputing.com/v2/workbooks/workbookId/swapConnections")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```

### Swap tables to different connections

**Request**

```json
{
  "connectionMapping": [
    {
      "fromId": "11111111-1111-1111-1111-111111111111",
      "toId": "22222222-2222-2222-2222-222222222222",
      "swapTables": true,
      "paths": [
        {
          "fromPath": [
            "PROD_DB",
            "SALES",
            "ORDERS"
          ],
          "toPath": [
            "PROD_DB",
            "SALES",
            "ORDERS"
          ]
        }
      ]
    },
    {
      "fromId": "33333333-3333-3333-3333-333333333333",
      "toId": "44444444-4444-4444-4444-444444444444",
      "swapTables": true,
      "paths": [
        {
          "fromPath": [
            "DEV_DB",
            "SALES",
            "CUSTOMERS"
          ],
          "toPath": [
            "ANALYTICS",
            "PUBLIC",
            "CUSTOMERS"
          ]
        }
      ]
    }
  ]
}
```

**Response**

```json
{
  "unswappedSources": [
    "string"
  ],
  "unswappedConnections": [
    "string"
  ]
}
```

**SDK Code**

```python Swap tables to different connections
import requests

url = "https://api.sigmacomputing.com/v2/workbooks/workbookId/swapConnections"

payload = { "connectionMapping": [
        {
            "fromId": "11111111-1111-1111-1111-111111111111",
            "toId": "22222222-2222-2222-2222-222222222222",
            "swapTables": True,
            "paths": [
                {
                    "fromPath": ["PROD_DB", "SALES", "ORDERS"],
                    "toPath": ["PROD_DB", "SALES", "ORDERS"]
                }
            ]
        },
        {
            "fromId": "33333333-3333-3333-3333-333333333333",
            "toId": "44444444-4444-4444-4444-444444444444",
            "swapTables": True,
            "paths": [
                {
                    "fromPath": ["DEV_DB", "SALES", "CUSTOMERS"],
                    "toPath": ["ANALYTICS", "PUBLIC", "CUSTOMERS"]
                }
            ]
        }
    ] }
headers = {
    "Authorization": "<token>.",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript Swap tables to different connections
const url = 'https://api.sigmacomputing.com/v2/workbooks/workbookId/swapConnections';
const options = {
  method: 'POST',
  headers: {Authorization: '<token>.', 'Content-Type': 'application/json'},
  body: '{"connectionMapping":[{"fromId":"11111111-1111-1111-1111-111111111111","toId":"22222222-2222-2222-2222-222222222222","swapTables":true,"paths":[{"fromPath":["PROD_DB","SALES","ORDERS"],"toPath":["PROD_DB","SALES","ORDERS"]}]},{"fromId":"33333333-3333-3333-3333-333333333333","toId":"44444444-4444-4444-4444-444444444444","swapTables":true,"paths":[{"fromPath":["DEV_DB","SALES","CUSTOMERS"],"toPath":["ANALYTICS","PUBLIC","CUSTOMERS"]}]}]}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Swap tables to different connections
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.sigmacomputing.com/v2/workbooks/workbookId/swapConnections"

	payload := strings.NewReader("{\n  \"connectionMapping\": [\n    {\n      \"fromId\": \"11111111-1111-1111-1111-111111111111\",\n      \"toId\": \"22222222-2222-2222-2222-222222222222\",\n      \"swapTables\": true,\n      \"paths\": [\n        {\n          \"fromPath\": [\n            \"PROD_DB\",\n            \"SALES\",\n            \"ORDERS\"\n          ],\n          \"toPath\": [\n            \"PROD_DB\",\n            \"SALES\",\n            \"ORDERS\"\n          ]\n        }\n      ]\n    },\n    {\n      \"fromId\": \"33333333-3333-3333-3333-333333333333\",\n      \"toId\": \"44444444-4444-4444-4444-444444444444\",\n      \"swapTables\": true,\n      \"paths\": [\n        {\n          \"fromPath\": [\n            \"DEV_DB\",\n            \"SALES\",\n            \"CUSTOMERS\"\n          ],\n          \"toPath\": [\n            \"ANALYTICS\",\n            \"PUBLIC\",\n            \"CUSTOMERS\"\n          ]\n        }\n      ]\n    }\n  ]\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "<token>.")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Swap tables to different connections
require 'uri'
require 'net/http'

url = URI("https://api.sigmacomputing.com/v2/workbooks/workbookId/swapConnections")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = '<token>.'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"connectionMapping\": [\n    {\n      \"fromId\": \"11111111-1111-1111-1111-111111111111\",\n      \"toId\": \"22222222-2222-2222-2222-222222222222\",\n      \"swapTables\": true,\n      \"paths\": [\n        {\n          \"fromPath\": [\n            \"PROD_DB\",\n            \"SALES\",\n            \"ORDERS\"\n          ],\n          \"toPath\": [\n            \"PROD_DB\",\n            \"SALES\",\n            \"ORDERS\"\n          ]\n        }\n      ]\n    },\n    {\n      \"fromId\": \"33333333-3333-3333-3333-333333333333\",\n      \"toId\": \"44444444-4444-4444-4444-444444444444\",\n      \"swapTables\": true,\n      \"paths\": [\n        {\n          \"fromPath\": [\n            \"DEV_DB\",\n            \"SALES\",\n            \"CUSTOMERS\"\n          ],\n          \"toPath\": [\n            \"ANALYTICS\",\n            \"PUBLIC\",\n            \"CUSTOMERS\"\n          ]\n        }\n      ]\n    }\n  ]\n}"

response = http.request(request)
puts response.read_body
```

```java Swap tables to different connections
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.sigmacomputing.com/v2/workbooks/workbookId/swapConnections")
  .header("Authorization", "<token>.")
  .header("Content-Type", "application/json")
  .body("{\n  \"connectionMapping\": [\n    {\n      \"fromId\": \"11111111-1111-1111-1111-111111111111\",\n      \"toId\": \"22222222-2222-2222-2222-222222222222\",\n      \"swapTables\": true,\n      \"paths\": [\n        {\n          \"fromPath\": [\n            \"PROD_DB\",\n            \"SALES\",\n            \"ORDERS\"\n          ],\n          \"toPath\": [\n            \"PROD_DB\",\n            \"SALES\",\n            \"ORDERS\"\n          ]\n        }\n      ]\n    },\n    {\n      \"fromId\": \"33333333-3333-3333-3333-333333333333\",\n      \"toId\": \"44444444-4444-4444-4444-444444444444\",\n      \"swapTables\": true,\n      \"paths\": [\n        {\n          \"fromPath\": [\n            \"DEV_DB\",\n            \"SALES\",\n            \"CUSTOMERS\"\n          ],\n          \"toPath\": [\n            \"ANALYTICS\",\n            \"PUBLIC\",\n            \"CUSTOMERS\"\n          ]\n        }\n      ]\n    }\n  ]\n}")
  .asString();
```

```php Swap tables to different connections
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.sigmacomputing.com/v2/workbooks/workbookId/swapConnections', [
  'body' => '{
  "connectionMapping": [
    {
      "fromId": "11111111-1111-1111-1111-111111111111",
      "toId": "22222222-2222-2222-2222-222222222222",
      "swapTables": true,
      "paths": [
        {
          "fromPath": [
            "PROD_DB",
            "SALES",
            "ORDERS"
          ],
          "toPath": [
            "PROD_DB",
            "SALES",
            "ORDERS"
          ]
        }
      ]
    },
    {
      "fromId": "33333333-3333-3333-3333-333333333333",
      "toId": "44444444-4444-4444-4444-444444444444",
      "swapTables": true,
      "paths": [
        {
          "fromPath": [
            "DEV_DB",
            "SALES",
            "CUSTOMERS"
          ],
          "toPath": [
            "ANALYTICS",
            "PUBLIC",
            "CUSTOMERS"
          ]
        }
      ]
    }
  ]
}',
  'headers' => [
    'Authorization' => '<token>.',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp Swap tables to different connections
using RestSharp;

var client = new RestClient("https://api.sigmacomputing.com/v2/workbooks/workbookId/swapConnections");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "<token>.");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"connectionMapping\": [\n    {\n      \"fromId\": \"11111111-1111-1111-1111-111111111111\",\n      \"toId\": \"22222222-2222-2222-2222-222222222222\",\n      \"swapTables\": true,\n      \"paths\": [\n        {\n          \"fromPath\": [\n            \"PROD_DB\",\n            \"SALES\",\n            \"ORDERS\"\n          ],\n          \"toPath\": [\n            \"PROD_DB\",\n            \"SALES\",\n            \"ORDERS\"\n          ]\n        }\n      ]\n    },\n    {\n      \"fromId\": \"33333333-3333-3333-3333-333333333333\",\n      \"toId\": \"44444444-4444-4444-4444-444444444444\",\n      \"swapTables\": true,\n      \"paths\": [\n        {\n          \"fromPath\": [\n            \"DEV_DB\",\n            \"SALES\",\n            \"CUSTOMERS\"\n          ],\n          \"toPath\": [\n            \"ANALYTICS\",\n            \"PUBLIC\",\n            \"CUSTOMERS\"\n          ]\n        }\n      ]\n    }\n  ]\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift Swap tables to different connections
import Foundation

let headers = [
  "Authorization": "<token>.",
  "Content-Type": "application/json"
]
let parameters = ["connectionMapping": [
    [
      "fromId": "11111111-1111-1111-1111-111111111111",
      "toId": "22222222-2222-2222-2222-222222222222",
      "swapTables": true,
      "paths": [
        [
          "fromPath": ["PROD_DB", "SALES", "ORDERS"],
          "toPath": ["PROD_DB", "SALES", "ORDERS"]
        ]
      ]
    ],
    [
      "fromId": "33333333-3333-3333-3333-333333333333",
      "toId": "44444444-4444-4444-4444-444444444444",
      "swapTables": true,
      "paths": [
        [
          "fromPath": ["DEV_DB", "SALES", "CUSTOMERS"],
          "toPath": ["ANALYTICS", "PUBLIC", "CUSTOMERS"]
        ]
      ]
    ]
  ]] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.sigmacomputing.com/v2/workbooks/workbookId/swapConnections")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```